<?php

namespace Myquest\Controller;

class ImageController
{
    protected $entityManager;
    public function __construct($connectionParams, $connectionCustomDois, $entityManager)
    {
        $this->connectionParams = $connectionParams;
        $this->connectionCustomDois = $connectionCustomDois;
        $this->entityManager = $entityManager;
    }

    private function _getImg($id, $NRORG)
    {
        $query = "SELECT BASE64ENCODE(FGFOTOPRATO) AS FGFOTOPRATO FROM FOTOPRATOBLOB S WHERE NRFOTOPRATOBLOB = :NRFOTOPRATOBLOB";
        $newEntity = $this->connectionCustomDois->updateVpdConnection($NRORG);
        $this->entityManager = $newEntity === false ? $this->entityManager : $newEntity;
        
        $conn = $this->entityManager->getConnection();
        $statement = $conn->prepare($query);
        $statement->execute($id);
        $image = $statement->fetchAll();
        if (count($image) > 0) {
            $code_base64 = $image[0]["FGFOTOPRATO"];
            $code_base64 = str_replace('data:image/jpeg;base64,', '', $code_base64);
            $code_binary = base64_decode($code_base64);
            $image = imagecreatefromstring($code_binary);
            header('Content-Type: image/jpeg');
            header('Cache-Control: public, max-age=31536000');
            imagejpeg($image);
            imagedestroy($image);
            die;
        } else {
            http_response_code(404);
        }
    }

    public function getImage($request)
    {
        $params = $request->getParameters();
        $id = ["NRFOTOPRATOBLOB" => $params["id"]];
        $NRORG = $params["nrorg"];
        
        try {
            $this->_getImg($id, $NRORG);
        } catch (\Exception $th) {
            var_dump($th);
        }
    }
}
